<!doctype html>
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

        <title>Slides - étude de cas Stargate</title>

        <link rel="stylesheet" href="reveal.js/dist/reset.css">
        <link rel="stylesheet" href="reveal.js/dist/reveal.css">
        <link rel="stylesheet" href="reveal.js/dist/theme/black.css">

        <!-- Theme used for syntax highlighted code -->
        <link rel="stylesheet" href="reveal.js/plugin/highlight/monokai.css">
    </head>
    <body>
        <div class="reveal">
            <div class="slides">
                <section>
                    <section data-markdown>
                      <textarea data-template>
                        # Stargate
                        Passer d'un déploiement continu à un environnement air-gaped ; étude de cas
                        ---
                        ## Votre interlocuteur
                        * gael-demette.fr
                        * Développeur "fullstack" (verticalement et horizontalement)
                        * Président de Qonfucius (& sa marque Qongzi)
                      </textarea>
                    </section>
                </section>
                <section>
                    <section data-markdown>
                        <textarea data-template>
                            # Contexte
                            Comment en est-on arrivés là ?
                            ---
                            ## Caractéristiques métier
                            * Un logiciel de gestion des accès pour les bases de défense
                            * Développé sur Internet par une équipe mixte CDAD + Externes
                            * Visant à être déployé sur un réseau défense dit air-gaped
                            * Visant à créer des interactions via des passerelles sur d'autres réseaux (réseau gendarmerie ?)
                            * Projet **A**gile
                            ---
                            ## Caractéristiques techniques
                            ![Le choix est issu d'un débat entre les différents acteurs pour trouver un terrain d'entente](./choix-techno.jpg)
                            ---
                            ## CI/CD et Igloo
                            Igloo est le nom donné à une équipe/programme interne à l'incubateur, ayant pour but de supporter les projets sur des écosystèmes de développement et production via une méthodologie devOps.
                            * ~ 10 projets
                            * Opensource
                            * Stack Terraform + Gitlab + Helm + Kubernetes + Docker
                        </textarea>
                    </section>
                </section>
                <section>
                    <section data-markdown>
                        <textarea data-template>
                            # CI/CD du projet
                            Igloo, piles incluses.
                            ---
                            ## Infrastructure as code
                            * Un opérateur : Terraform
                            * Un orchestrateur : Helm
                            * Un chef d'orchestre : Kubernetes
                            * Gitlab : abstraire la configuration pour les développeurs
                            * Ouverture de la contribution
                            ---
                            ## Fragment de pipeline ?
                            Une règle simple :
                            * Si c'est include, la maintenance impute à l'équipe Igloo
                            * Sinon, la maintenance impute à l'équipe projet
                            ---
                            ## Workflow
                            * Build : on construit l'image OCI, on la pousse dans le registry gitlab
                            * On test le code, le conteneur, les dépendances, les licenses...
                              * Une grosse part est proxy de ce que propose déjà gitlab
                            * On déploie le chart Helm
                            * On peut tester le déploiement (perfs, DAST...)
                            ---
                            ## Gitlab flow
                            * Une branche par défaut, correspondant à un environnement de staging
                            * Tag -> Production
                            * Le reste, review app
                        </textarea>
                    </section>
                </section>
                <section>
                    <section data-markdown>
                        <textarea data-template>
                            # 💩
                            Il faut livrer à une ESN détentrice du marché public, un zip, pour déployer sans docker, sur un centos 7 sans internet.
                            ---
                            ## Cible
                            Livrer un .tar.bz2 (🤫) avec :
                            * les dépendances OS
                            * les node_modules
                            * le front compilé
                            * les dépendances logiciels
                            * la documentation format pdf
                            ---
                            ## Mais... Pourquoi ?
                            * Copie de l'archive provenant d'internet sur support de stockage
                            * 🔎 🤫
                            * Décompression de l'archive sur le réseau hors internet, sur une machine d'administration
                            * Suivre la documentation d'installation, où seul les éléments contenu dans l'archive peuvent être appelés
                            ---
                            ## Vous avez dit devOps ?
                            * Bien séparer les responsabilités
                            * Rester Dry
                            * Rester simple
                            ---
                            ## Workflow
                            ![Diagramme du workflow](./workflow-stargate.png)
                            * Création d'[un script](https://gitlab.com/fabnum-minarm/igloo/images/tools/igloo-releaser/-/blob/develop/igloo-releaser.sh) (~80 lignes de bash) de "meta-releasing"
                            * Création d'un fichier `.toml` dans le "meta-repo", décrivant ce qu'il doit aller récupérer
                            * Spécifique avant la construction de l'archive
                            ---
                            ```toml
                            copy = ["dist/docs.*"]

                            [binaries]
                            get = [
                                "https://forensics.cert.org/centos/cert/7/x86_64/musl-filesystem-1.2.1-1.el7.x86_64.rpm",
                                "https://repo.mongodb.org/yum/redhat/7/mongodb-org/5.0/x86_64/RPMS/mongodb-org-server-5.0.5-1.el7.x86_64.rpm",
                                "https://nodejs.org/dist/v14.18.3/node-v14.18.3-linux-x64.tar.xz",
                                "[...]"
                            ]
                            copy = ["pm2.tar.bz2"]

                            [stargate_backend]
                            uncompress = ["https://gitlab.com/api/v4/projects/15793090/packages/generic/stargate_backend/$CI_COMMIT_TAG/stargate_backend_$CI_COMMIT_TAG.tar.bz2"]

                            [stargate_frontend]
                            uncompress = ["https://gitlab.com/api/v4/projects/15793082/packages/generic/stargate_frontend/$CI_COMMIT_TAG/stargate_frontend_$CI_COMMIT_TAG.tar.bz2"]
                            ```
                            ---
                            ## Documentation
                            La documentation utilisait mdbook, pour être déployée en ligne sur gitlab pages.

                            -> Il a suffi de réorganiser l'ordre des fichiers, puis passer le markdown à pandoc.
                            ---
                            ## Dépendances OS & logiciels
                            * On indique dans le `.toml` la liste exhaustive des logiciels et dépendances à télécharger
                            * PM2 : On créé un conteneur vierge avec la version cible (os et nodejs), on installe pm2, puis on extrait une archive des node_modules de l'utilisateur Unix, il suffit alors de recréer les liens symboliques sur la machine de production
                            ---
                            ## Sous-projets
                            * Les dépendances sont téléchargées dans la CI du projet.
                            * Le projet est construit dans la CI du projet
                            * La CI enrichi le tag avec une release, via le "generic release" de gitlab, pour y ajouter l'archive prête
                            * Le "meta-releaser" va chercher cette archive (la décompresser, pour éviter à l'opérateur humain qui déploie d'avoir des archives dans les archives, on pense à lui 🤟)
                            ---
                            ## Améliorations
                            * Enforce les signatures sha1 quand c'est possible
                            * Multi arch
                            * Utiliser des child-pipelines ?
                            * ... Attendre le retour d'autres projets
                            * ... Attendre une règlementation plus souple
                        </textarea>
                    </section>
                </section>
                <section>Des questions ? 🫵 C'est à vous</section>
                <section>
                    <section data-markdown>
                        <textarea data-template>
                            # Mentions utiles
                            * Argent public, code public
                              * https://gitlab.com/fabnum-minarm/stargate
                              * https://gitlab.com/fabnum-minarm/igloo/terraform/projects/stargate/
                            * Slides sur https://bit.ly/3JZTSTo (https://qonfucius.gitlab.io/conferences/meetup/nodejs-paris/2022-stargate-delivery-airgap/)
                            * [Qongzi.fr](https://qongzi.com/fr/) -> "On recrute"
                            * [Qongzi.fr](https://qongzi.com/fr/) peut vous proposer des prestations cyberSec, UI/UX, devOps et développement
                            ---
                            # Mentions honorables
                            * Samuel, pour avoir trouvé l'acronyme "Système de Traitement des Accès Réglementés Généralisé A Toutes les Entités"
                        </textarea>
                    </section>
                </section>
            </div>
        </div>

        <script src="reveal.js/dist/reveal.js"></script>
        <script src="reveal.js/plugin/notes/notes.js"></script>
        <script src="reveal.js/plugin/markdown/markdown.js"></script>
        <script src="reveal.js/plugin/highlight/highlight.js"></script>
        <script>
            Reveal.initialize({
                hash: true,
                plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
            });
        </script>
    </body>
</html>
